#include <stdlib.h>
#include <string.h>
#include <stdarg.h>

#include "monarch.h"
#include "traces.h"
#include "packet.h"

PcapPacketTrace::PcapPacketTrace()
{
  myDumper = NULL;
  myPcap = NULL;
}

void PcapPacketTrace::init()
{
  myPcap = pcap_open_dead(DLT_RAW, 4096);
  if (!myPcap)
    panic(ERR_INTERNAL, "Cannot initialize pcap library");
  char buf[1000];
  myDumper = pcap_dump_open(myPcap, outFileName);
  if (!myDumper)
    panic(ERR_FILEIO, "Cannot create pcap trace '%s'", outFileName);
}

void PcapPacketTrace::finalize()
{
  assert(myDumper && myPcap);
  pcap_dump_close(myDumper);
  myDumper = NULL;
  myPcap = NULL;
}

void PcapPacketTrace::addComment(const char *format, ...)
{
}

void PcapPacketTrace::addPacket(struct timeval *time, Packet *packet)
{
  assert(myDumper && myPcap);
  
  struct pcap_pkthdr hdr;
  hdr.ts = *time;
  hdr.caplen = packet->getIpLength();
  hdr.len = hdr.caplen;
  pcap_dump((u_char*)myDumper, &hdr, packet->getBuffer());
}
